Index: moodle/lib/navigationlib.php
--- moodle/lib/navigationlib.php Base (1.86)
+++ moodle/lib/navigationlib.php Locally Modified (Based On 1.86)
@@ -1154,204 +1321,9 @@
     }
 
     /**
-     * Adds the provided user to an array and when the navigation is generated
-     * it is extended for this user.
+     * This method simply checks to see if a given module can extend the navigation.
      *
-     * @param object $user
-     */
-    public function extend_for_user($user) {
-        $this->extendforuser[] = $user;
-    }
-
-    /**
-     * Called by the initalise methods if the context was system or category
-     *
-     * @param bool $lookforid If system context then we dont want ID because
-     *      it could be userid, courseid, or anything else
-     * @return int The depth to the active(requested) node
-     */
-    protected function load_for_category($lookforid=true) {
-        global $PAGE, $CFG;
-        $id = optional_param('id', null, PARAM_INT);
-        if ($lookforid && $id!==null) {
-            if (!empty($CFG->navshowallcourses)) {
-                $this->load_categories();
-            }
-            $this->load_categories($id);
-            $depth = $this->find_child_depth($id);
-        } else {
-            $depth = $this->load_categories();
-        }
-        return $depth;
-    }
-
-    /**
-     * Called by the initialise methods if the context was course
-     *
-     * @return int The depth to the active(requested) node
-     */
-    protected function load_for_course() {
-        global $PAGE, $CFG, $USER;
-        $keys = array();
-        if (!empty($CFG->navshowallcourses)) {
-            $this->load_categories();
-        }
-        $depth = $this->load_course_categories($keys);
-        $depth += $this->load_course($keys);
-        if (!$this->format_display_course_content($PAGE->course->format)) {
-            $child = $this->get_by_path($keys);
-            if ($child!==false) {
-                $child->nodetype = self::NODETYPE_LEAF;
-            }
-            return $depth;
-        }
-
-        if (isloggedin() && has_capability('moodle/course:participate', get_context_instance(CONTEXT_COURSE, $PAGE->course->id))) {
-            $depth += $this->load_course_activities($keys);
-            $depth += $this->load_course_sections($keys);
-        }
-        return $depth;
-    }
-
-    /**
-     * Check whether the course format defines a display_course_content function
-     * that can be used to toggle whether or not to display course content
-     *
-     * $default is set to true, which may seem counter productive, however it ensures
-     * backwards compatibility for course types that havn't yet defined the callback
-     *
-     * @param string $format
-     * @param bool $default
-     * @return bool
-     */
-    protected function format_display_course_content($format, $default=true) {
-        global $CFG;
-        $formatlib = $CFG->dirroot.'/course/format/'.$format.'/lib.php';
-        if (file_exists($formatlib)) {
-            require_once($formatlib);
-            $displayfunc = 'callback_'.$format.'_display_content';
-            if (function_exists($displayfunc) && !$displayfunc()) {
-                return $displayfunc();
-            }
-        }
-        return $default;
-    }
-
-    /**
-     * Internal method to load course activities into the global navigation structure
-     * Course activities are activities that are in section 0
-     *
-     * @param array $keys By reference
-     */
-    protected function load_course_activities(&$keys, $course=null) {
-        global $PAGE, $CFG, $FULLME;
-
-        if ($course === null) {
-            $course = $PAGE->course;
-        }
-
-        if (!$this->cache->compare('modinfo'.$course->id, $course->modinfo, false)) {
-            $this->cache->{'modinfo'.$course->id} = get_fast_modinfo($course);
-        }
-        $modinfo =  $this->cache->{'modinfo'.$course->id};
-
-        if (!$this->cache->cached('canviewhiddenactivities')) {
-            $this->cache->canviewhiddenactivities = has_capability('moodle/course:viewhiddenactivities', $this->context);
-        }
-        $viewhiddenactivities = $this->cache->canviewhiddenactivities;
-
-        $labelformatoptions = new object();
-        $labelformatoptions->noclean = true;
-        $labelformatoptions->para = false;
-
-        foreach ($modinfo->cms as $module) {
-            if ($module->sectionnum!='0' || (!$viewhiddenactivities && !$module->visible)) {
-                continue;
-            }
-            $icon = null;
-            if ($module->icon) {
-                $icon = new pix_icon($module->icon, '', $module->iconcomponent);
-            } else {
-                $icon = new pix_icon('icon', '', $module->modname);
-            }
-            $url = new moodle_url('/mod/'.$module->modname.'/view.php', array('id'=>$module->id));
-            $this->add_to_path($keys, $module->id, $module->name, $module->name, self::TYPE_ACTIVITY, $url, $icon);
-            $child = $this->find_child($module->id, self::TYPE_ACTIVITY);
-            if ($child != false) {
-                $child->title(get_string('modulename', $module->modname));
-                if ($this->module_extends_navigation($module->modname)) {
-                    $child->nodetype = self::NODETYPE_BRANCH;
-                }
-                if (!$module->visible) {
-                    $child->hidden = true;
-                }
-            }
-        }
-    }
-    /**
-     * Internal function to load the activities within sections
-     *
-     * @param array $keys By reference
-     */
-    protected function load_section_activities(&$keys, $singlesectionid=false, $course=null) {
-        global $PAGE, $CFG, $FULLME;
-
-        if ($course === null) {
-            $course = $PAGE->course;
-        }
-
-        if (!$this->cache->compare('modinfo'.$course->id, $course->modinfo, false)) {
-            $this->cache->{'modinfo'.$course->id} = get_fast_modinfo($course);
-        }
-        $modinfo =  $this->cache->{'modinfo'.$course->id};
-
-        if (!$this->cache->cached('coursesections'.$course->id)) {
-            $this->cache->{'coursesections'.$course->id} = get_all_sections($course->id);
-        }
-        $sections = $this->cache->{'coursesections'.$course->id};
-
-        if (!$this->cache->cached('canviewhiddenactivities')) {
-            $this->cache->canviewhiddenactivities = has_capability('moodle/course:viewhiddenactivities', $this->context);
-        }
-        $viewhiddenactivities = $this->cache->viewhiddenactivities;
-
-        $labelformatoptions = new object();
-        $labelformatoptions->noclean = true;
-        $labelformatoptions->para = false;
-
-        foreach ($modinfo->cms as $module) {
-            if ($module->sectionnum=='0' || (!$viewhiddenactivities && !$module->visible) || ($singlesectionid!=false && $module->sectionnum!==$singlesectionid)) {
-                continue;
-            }
-            $icon = null;
-            if ($module->icon) {
-                $icon = new pix_icon($module->icon, '', $module->iconcomponent);
-            } else {
-                $icon = new pix_icon('icon', '', $module->modname);
-            }
-            $url = new moodle_url('/mod/'.$module->modname.'/view.php', array('id'=>$module->id));
-
-            $path = $keys;
-            if ($course->id !== SITEID) {
-                $path[] = $sections[$module->sectionnum]->id;
-            }
-            $this->add_to_path($path, $module->id, $module->name, $module->name, navigation_node::TYPE_ACTIVITY, $url, $icon);
-            $child = $this->find_child($module->id, navigation_node::TYPE_ACTIVITY);
-            if ($child != false) {
-                $child->title(get_string('modulename', $module->modname));
-                if (!$module->visible) {
-                    $child->hidden = true;
-                }
-                if ($this->module_extends_navigation($module->modname)) {
-                    $child->nodetype = self::NODETYPE_BRANCH;
-                }
-            }
-        }
-    }
-
-    /**
-     * Check if a given module has a method to extend the navigation
-     *
+     * @global stdClass $CFG
      * @param string $modname
      * @return bool
      */
@@ -1376,200 +1348,65 @@
         return false;
     }
     /**
-     * Load the global navigation structure for an activity
+     * Extends the navigation for the given user.
      *
-     * @return int
+     * @param stdClass $user A user from the database
      */
-    protected function load_for_activity() {
-        global $PAGE, $DB, $CFG;
-        $keys = array();
-
-        $sectionnum = false;
-        if (!empty($PAGE->cm->section)) {
-            $section = $DB->get_record('course_sections', array('id'=>$PAGE->cm->section));
-            if (!empty($section->section)) {
-                $sectionnum = $section->section;
+    public function extend_for_user($user) {
+        $this->extendforuser[] = $user;
             }
-        }
-
-        if (!empty($CFG->navshowallcourses)) {
-            $this->load_categories();
-        }
-
-        $depth = $this->load_course_categories($keys);
-        $depth += $this->load_course($keys);
-        $depth += $this->load_course_activities($keys);
-        $depth += $this->load_course_sections($keys);
-        $depth += $this->load_section_activities($keys,$sectionnum);
-        $depth += $this->load_activity($keys);
-        return $depth;
-    }
-
     /**
-     * This function loads any navigation items that might exist for an activity
-     * by looking for and calling a function within the modules lib.php
+     * Adds the given course to the navigation structure.
      *
-     * @param int $instanceid
-     * @return void
+     * @param stdClass $course
+     * @return navigation_node
      */
-    protected function load_activity($keys) {
-        global $CFG, $PAGE;
-
-        if (!$PAGE->cm && $this->context->contextlevel == CONTEXT_MODULE && $this->context->instanceid) {
-            // This is risky but we have no other choice... we need that module and the module
-            // itself hasn't set PAGE->cm (usually set by require_login)
-            // Chances are this is a front page module.
-            $cm = get_coursemodule_from_id(false, $this->context->instanceid);
-            $PAGE->set_cm($cm, $PAGE->course);
+    public function add_course(stdClass $course) {
+        if (array_key_exists($course->id, $this->addedcourses)) {
+            return $this->addedcourses[$course->id];
         }
 
-        $node = $this->find_child($PAGE->cm->id, self::TYPE_ACTIVITY);
-        if ($node) {
-            $node->make_active();
-            $this->context = $PAGE->context;
-            $file = $CFG->dirroot.'/mod/'.$PAGE->activityname.'/lib.php';
-            $function = $PAGE->activityname.'_extend_navigation';
-
-            if (file_exists($file)) {
-                require_once($file);
-                if (function_exists($function)) {
-                    $function($node, $PAGE->course, $PAGE->activityrecord, $PAGE->cm);
+        $canviewhidden = has_capability('moodle/course:viewhiddencourses', $this->page->context);
+        if ($course->id !== SITEID && !$canviewhidden && (!$course->visible || !course_parent_visible($course))) {
+            return false;
                 }
-            }
-        }
-    }
 
-    /**
-     * Recursively adds an array of category objexts to the path provided by $keys
-     *
-     * @param array $keys An array of keys representing the path to add to
-     * @param array $categories An array of [nested] categories to add
-     * @param int $depth The current depth, this ensures we don't generate more than
-     *      we need to
-     */
-    protected function add_categories(&$keys, $categories, $depth=0) {
-        if (is_array($categories) && count($categories)>0) {
-            foreach ($categories as $category) {
-                $url = new moodle_url('/course/category.php', array('id'=>$category->id, 'categoryedit'=>'on', 'sesskey'=>sesskey()));
-                $categorykey = $this->add_to_path($keys,  $category->id, $category->name, $category->name, self::TYPE_CATEGORY, $url);
-                if ($depth < $this->depthforward) {
-                    $this->add_categories(array_merge($keys, array($categorykey)), $category->id, $depth+1);
-                }
-            }
-        }
-    }
-
-    /**
-     * This function adds a category to the nav tree based on the categories path
-     *
-     * @param stdClass $category
-     */
-    protected function add_category_by_path($category) {
-        $url = new moodle_url('/course/category.php', array('id'=>$category->id, 'categoryedit'=>'on', 'sesskey'=>sesskey()));
-        $keys = explode('/',trim($category->path,'/ '));
-        // Check this category hadsn't already been added
-        if (!$this->get_by_path($keys)) {
-            $currentcategory = array_pop($keys);
-            $categorykey = $this->add_to_path($keys,  $category->id, $category->name, $category->name, self::TYPE_CATEGORY, $url);
-        } else {
-            $currentcategory = array_pop($keys);
-            $categorykey = $currentcategory.':'.self::TYPE_CATEGORY;
-        }
-        return $categorykey;
-    }
-
-    /**
-     * Adds an array of courses to thier correct categories if the categories exist
-     *
-     * @param array $courses An array of course objects
-     * @param int $categoryid An override to add the courses to
-     * @return bool
-     */
-    public function add_courses($courses, $categoryid=null) {
-        global $SITE;
-        if (is_array($courses) && count($courses)>0) {
-            // Work out if the user can view hidden courses, just incase
-            if (!$this->cache->cached('canviewhiddencourses')) {
-                $this->cache->canviewhiddencourses = has_capability('moodle/course:viewhiddencourses', $this->context);
-            }
-            $canviewhidden = $this->cache->canviewhiddencourses;
-            $expandcourse = $this->can_display_type(self::TYPE_SECTION);
-            foreach ($courses as $course) {
-                // Check if the user can't view hidden courses and if the course is hidden, if so skip and continue
-                if ($course->id!=$SITE->id && !$canviewhidden && (!$course->visible || !course_parent_visible($course))) {
-                    continue;
-                }
-                // Process this course into the nav structure
+        if ($course->id == SITEID) {
+            $parent = $this;
+            $url = new moodle_url('/');
+        } else if (array_key_exists($course->id, $this->mycourses)) {
+            $parent = $this->rootnodes['mycourses'];
                 $url = new moodle_url('/course/view.php', array('id'=>$course->id));
-                if ($categoryid===null) {
-                    $category = $this->find_child($course->category, self::TYPE_CATEGORY);
-                } else if ($categoryid === false) {
-                    $category = $this;
                 } else {
-                    $category = $this->find_child($categoryid);
+            $parent = $this->rootnodes['courses'];
+            $url = new moodle_url('/course/view.php', array('id'=>$course->id));
                 }
-                if ($category!==false) {
-                    // Check that this course hasn't already been added.
-                    // This function only adds a skeleton and we don't want to overwrite
-                    // a fully built course object
-                    if (!$category->get($course->id, self::TYPE_COURSE)) {
-                        $coursekey = $category->add($course->fullname, $url, self::TYPE_COURSE, $course->shortname, $course->id, new pix_icon('i/course', ''));
-                        if (!$course->visible) {
-                            $category->get($course->id)->hidden = true;
+        $coursenode = $parent->add($course->fullname, $url, self::TYPE_COURSE, $course->shortname, $course->id);
+        $coursenode->nodetype = self::NODETYPE_BRANCH;
+        $coursenode->hidden = (!$course->visible);
+        $this->addedcourses[$course->id] = &$coursenode;
+        return $coursenode;
                         }
-                        if ($expandcourse!==true) {
-                            $category->get($course->id)->nodetype = self::NODETYPE_LEAF;
-                        }
-                    }
-                }
-            }
-        }
-        return true;
-    }
-
     /**
-     * Loads the current course into the navigation structure
+     * Adds essential course nodes to the navigation for the given course.
      *
-     * Loads the current course held by $PAGE {@link moodle_page()} into the navigation
-     * structure.
-     * If the course structure has an appropriate display method then the course structure
-     * will also be displayed.
+     * This method adds nodes such as reports, blogs and participants
      *
-     * @param array $keys The path to add the course to
+     * @global stdClass $CFG
+     * @param navigation_node $coursenode
+     * @param stdClass $course
      * @return bool
      */
-    protected function load_course(&$keys, $course=null) {
-        global $PAGE, $CFG;
-        if ($course===null) {
-            $course = $PAGE->course;
-        }
-        if (is_object($course) && $course->id !== SITEID) {
+    public function add_course_essentials(navigation_node $coursenode, $course) {
+        global $CFG;
 
-            if (!$this->cache->cached('canviewhiddencourses')) {
-                $this->cache->canviewhiddencourses = has_capability('moodle/course:viewhiddencourses', $this->context);
+        if ($coursenode == false || $coursenode->get('participants', navigation_node::TYPE_CONTAINER)) {
+            return true;
             }
-            $canviewhidden = $this->cache->canviewhiddencourses;
-
-            if (!$canviewhidden && (!$course->visible || !course_parent_visible($course))) {
-                return;
-            }
-            $url = new moodle_url('/course/view.php', array('id'=>$course->id));
-            $keys[] = $this->add_to_path($keys, $course->id, $course->fullname, $course->shortname, self::TYPE_COURSE, $url, new pix_icon('i/course', ''));
-            $currentcourse = $this->find_child($course->id, self::TYPE_COURSE);
-            if ($currentcourse!==false){
-                $currentcourse->make_active();
-                if (!$course->visible) {
-                    $currentcourse->hidden = true;
-                }
-
                 //Participants
-                if (has_capability('moodle/course:viewparticipants', $this->context)) {
-                    $participantskey = $currentcourse->add(get_string('participants'), new moodle_url('/user/index.php?id='.$course->id), self::TYPE_SETTING, get_string('participants'), 'participants');
-                    $participants = $currentcourse->get($participantskey);
-                    if ($participants) {
-
+        if (has_capability('moodle/course:viewparticipants', $this->page->context)) {
+            $participants = $coursenode->add(get_string('participants'), new moodle_url('/user/index.php?id='.$course->id), self::TYPE_CONTAINER, get_string('participants'), 'participants');
                         require_once($CFG->dirroot.'/blog/lib.php');
-
                         $currentgroup = groups_get_course_group($course, true);
                         if ($course->id == SITEID) {
                             $filterselect = '';
@@ -1579,23 +1416,18 @@
                             $filterselect = $currentgroup;
                         }
                         $filterselect = clean_param($filterselect, PARAM_INT);
-
                         if ($CFG->bloglevel >= 3) {
                             $blogsurls = new moodle_url('/blog/index.php', array('courseid' => $filterselect));
                             $participants->add(get_string('blogs','blog'), $blogsurls->out());
                         }
-
-                        if (!empty($CFG->enablenotes) && (has_capability('moodle/notes:manage', $this->context) || has_capability('moodle/notes:view', $this->context))) {
+            if (!empty($CFG->enablenotes) && (has_capability('moodle/notes:manage', $this->page->context) || has_capability('moodle/notes:view', $this->page->context))) {
                             $participants->add(get_string('notes','notes'), new moodle_url('/notes/index.php', array('filtertype'=>'course', 'filterselect'=>$filterselect)));
                         }
                     }
-                }
 
                 // View course reports
-                if (has_capability('moodle/site:viewreports', $this->context)) { // basic capability for listing of reports
-                    $reportkey = $currentcourse->add(get_string('reports'), new moodle_url('/course/report.php', array('id'=>$course->id)), self::TYPE_SETTING, null, null, new pix_icon('i/stats', ''));
-                    $reportnav = $currentcourse->get($reportkey);
-                    if ($reportnav) {
+        if (has_capability('moodle/site:viewreports', $this->page->context)) { // basic capability for listing of reports
+            $reportnav = $coursenode->add(get_string('reports'), new moodle_url('/course/report.php', array('id'=>$course->id)), self::TYPE_CONTAINER, null, null, new pix_icon('i/stats', ''));
                         $coursereports = get_plugin_list('coursereport');
                         foreach ($coursereports as $report=>$dir) {
                             $libfile = $CFG->dirroot.'/course/report/'.$report.'/lib.php';
